Shader "CrispyPin/LibGarbageExample"
{
	Properties
	{
		[Header(Raymarcher Properties)]
		_MaxSteps ("Max steps", Int) = 128
		_MaxDist ("Max distance", Float) = 128
		_SurfDist ("Surface distance threshold", Range(0.00001, 0.05)) = 0.001

	}
	SubShader
	{
		Tags { "RenderType"="Opaque" }
		Cull Front
		LOD 100

		Pass
		{
			CGPROGRAM
			#pragma vertex vert
			#pragma fragment frag

			int _MaxSteps;
			#define MAX_STEPS _MaxSteps

			#define REFLECTIONS 1
			#define DISTANCE_FN main_dist
			#define MATERIAL_FN main_mat
			#define DISABLE_DEPTH
			#define DISCARD_ON_MISS
			#define USE_WORLD_SPACE
			#include "libgarbage.cginc"

			float main_dist(float3 p) {
				p = repXYZ(p, 2);
				return qSub(sdSphere(p, 0.5), sdSphere(p - 0.3, 0.2), 0.05);
			}

			SurfacePoint main_mat(float3 p) {
				float3 p2 = repXYZ(p, 2);
				return mSphere(p2, 0.5, mat(clamp(abs(p), 0, 1), 0.1));
			}

			ENDCG
		}
	}
}
